aboutsummaryrefslogtreecommitdiff
path: root/qa/rpc-tests/send.sh
diff options
context:
space:
mode:
authorGavin Andresen <gavinandresen@gmail.com>2014-02-12 21:33:00 -0500
committerGavin Andresen <gavinandresen@gmail.com>2014-02-13 10:25:42 -0500
commit867dfb4a088e884e8d428b69e72740aad0811303 (patch)
tree0714385ff2ca3407bc6778efcff6cfff80e5c806 /qa/rpc-tests/send.sh
parent19e5b9d2dfcac4efadba636745485d9660fb1abe (diff)
downloadbitcoin-867dfb4a088e884e8d428b69e72740aad0811303.tar.xz
Make qa/rpc-tests/ compatible with OSX
Reworked send.sh, so it works properly on my Mac (killall send.sh doesn't work, because the process name is 'bash' not 'send.sh'). So now send.sh writes a .send.pid file, and invoking it as send.sh -STOP (as the bitcoind -walletnotify) signals that PID.
Diffstat (limited to 'qa/rpc-tests/send.sh')
-rwxr-xr-xqa/rpc-tests/send.sh14
1 files changed, 14 insertions, 0 deletions
diff --git a/qa/rpc-tests/send.sh b/qa/rpc-tests/send.sh
index fdfb1867bc..2c0d5375c0 100755
--- a/qa/rpc-tests/send.sh
+++ b/qa/rpc-tests/send.sh
@@ -1,14 +1,28 @@
#!/bin/bash
TIMEOUT=10
SIGNAL=HUP
+PIDFILE=.send.pid
if [ $# -eq 0 ]; then
echo -e "Usage:\t$0 <cmd>"
echo -e "\tRuns <cmd> and wait ${TIMEOUT} seconds or until SIG${SIGNAL} is received."
echo -e "\tReturns: 0 if SIG${SIGNAL} is received, 1 otherwise."
+ echo -e "Or:\t$0 -STOP"
+ echo -e "\tsends SIG${SIGNAL} to running send.sh"
exit 0
fi
+
+if [ $1 == "-STOP" ]; then
+ if [ -s ${PIDFILE} ]; then
+ kill -s ${SIGNAL} $(<${PIDFILE})
+ fi
+ exit 0
+fi
+
trap '[[ ${PID} ]] && kill ${PID}' ${SIGNAL}
+trap 'rm -f ${PIDFILE}' EXIT
+echo $$ > ${PIDFILE}
"$@"
sleep ${TIMEOUT} & PID=$!
wait ${PID} && exit 1
+
exit 0